cordova.define("sino-cordova-plugin-permission.Permission", function(require, exports, module) {
  var exec = cordova.require('cordova/exec');

  exports.request = function(callback) {
    var win = function(result) {
      callback(result);
    };
    var fail = function(error) {
      if (callback) {
        callback(error);
      }
    };
    exec(win, fail, 'Permission', 'request', []);
  };
  exports.exitApp = function (callback) {
    var win = function(result) {
      if(callback) {
        callback(0);
      }
    };
    var fail = function(result) {
      if (callback) {
        callback(-1);
      }
    };
    exec(win, fail, 'Permission', 'exitApp', []);
  };
  exports.confirmPrivacy = function (callback) {
    var win = function(result) {
      if(callback) {
        callback(0);
      }
    };
    var fail = function(result) {
      if (callback) {
        callback(-1);
      }
    };
    exec(win, fail, 'Permission', 'confirmPrivacy', []);
  };
    //跳转设置页面
    exports.openSettings = function (arg0, success, error) {
       exec(success, error, 'Permission', 'openSettings', [arg0]);
    };
    //手机状态、身份权限（Android专用，iOS会做已授权返回，前端直接调用即可）
    exports.permissionTypeReadPhoneState = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeReadPhoneState', [arg0]);
    };
    //存储权限（Android专用，iOS会做已授权返回，前端直接调用即可）
    exports.permissionTypeRWStorage = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeRWStorage', [arg0]);
    };
    //通知（iOS 非必要权限，无需调用跟随系统弹窗）
    exports.permissionTypeNotification = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeNotification', [arg0]);
    };
    //定位权限
    exports.permissionTypeLocation = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeLocation', [arg0]);
    };
    //相机权限
    exports.permissionTypeCamera = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeCamera', [arg0]);
    };
    //相册权限（iOS专用，Android会做已授权返回，前端直接调用即可）
    exports.permissionTypePhotos = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypePhotos', [arg0]);
    };
    //拨号权限（Android专用，iOS会做已授权返回，前端直接调用即可）
    exports.permissionTypeTel = function (arg0, success, error) {
       exec(success, error, 'Permission', 'permissionTypeTel', [arg0]);
    };
    //首次询问权限，入参为约定好的方法标记，用于外壳记录首次询问
    exports.firstAskPermission = function (arg0, success, error) {
       exec(success, error, 'Permission', 'firstAskPermission', [arg0]);
    };
});

